## visad.bom
Class FlexibleTrackManipulation.FTMDirectManipulationRendererJ3D

    java.lang.Object
      visad.DataRenderer
          visad.java3d.RendererJ3D
              visad.java3d.DirectManipulationRendererJ3D
                  visad.bom.FlexibleTrackManipulation.FTMDirectManipulationRendererJ3D

All Implemented Interfaces:
  Cloneable

Enclosing class:
  FlexibleTrackManipulation

class FlexibleTrackManipulation.FTMDirectManipulationRendererJ3D
extends DirectManipulationRendererJ3D

Field Summary
`(package private) FlexibleTrackManipulation` `ftm`

Fields inherited from class visad.java3d.DirectManipulationRendererJ3D
``

Fields inherited from class visad.java3d.RendererJ3D
``

Fields inherited from class visad.DataRenderer
`enabled, pickCrawlToCursor`

Constructor Summary
`(package private)` `FlexibleTrackManipulation.FTMDirectManipulationRendererJ3D(FlexibleTrackManipulation f)`

Method Summary
`void` `drag_direct(VisADRay ray, boolean first, int mouseModifiers)` modify Data values based on direct manipulation mouse actions
`void` `release_direct()` mouse button released, ending direct manipulation

Methods inherited from class visad.java3d.DirectManipulationRendererJ3D
`addPoint, checkDirect, clearScene, clone, doTransform, isLegalTextureMap, setBranch, setLinks`

Methods inherited from class visad.java3d.RendererJ3D
`clearBranch, doAction, flush, getBranch, makeShadowFunctionType, makeShadowRealTupleType, makeShadowRealType, makeShadowSetType, makeShadowTextType, makeShadowTupleType, setBranchEarly, toggle`

Methods inherited from class visad.DataRenderer

`addException, checkAction, checkClose, clearAVControls, clearExceptions, computeRanges, earthToSpatial, earthToSpatial, findRayManifoldIntersection, get_all_feasible, get_any_changed, get_any_transform_control, getBadScale, getDisplay, getDisplayCoordinateSystem, getDisplayRenderer, getEarthDimension, getEarthUnits, getEnabled, getExceptionVector, getIsDirectManipulation, getLastMouseModifiers, getLatLonIndices, getLatLonRange, getLink, getLinks, getPickCrawlToCursor, getRanges, getRealVectorTypes, getWhyNotDirect, isTransformControl, prepareAction, realCheckDirect, removeLink, set_all_feasible, setDisplay, setDisplayRenderer, setEarthSpatialData, setEarthSpatialDisplay, setIsDirectManipulation, setLastMouseModifiers, setLatLonIndices, setLinks, setPickCrawlToCursor, setSpatialValues, spatialToEarth, spatialToEarth, stop_direct, suppressExceptions`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ftm

    FlexibleTrackManipulation ftm

Constructor Detail

### FlexibleTrackManipulation.FTMDirectManipulationRendererJ3D

    FlexibleTrackManipulation.FTMDirectManipulationRendererJ3D(FlexibleTrackManipulation f)

Method Detail

### release_direct

    public void release_direct()

  mouse button released, ending direct manipulation

  Overrides:
    `release_direct` in class `DataRenderer`

### drag_direct

    public void drag_direct(VisADRay ray,
                            boolean first,
                            int mouseModifiers)

  Description copied from class: `DataRenderer`
  modify Data values based on direct manipulation mouse actions

  Overrides:
    `drag_direct` in class `DataRenderer`
  Parameters:
    `ray` - 3-D graphics coordinates of ray corresponding to mouse screen location
    `first` - flag if this is first call (for MouseEvent.MOUSE_PRESSED, not for MouseEvent.MOUSE_DRAGGED)
    `mouseModifiers` - value of InputEvent.getModifiers() from most recent direct manipulation mouse click